"""

    Quick install script for Custom Search product
    
    Copyright 2006 Red Innovation
    

"""
from StringIO import StringIO
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore import MembershipTool
from Products.CMFCore.permissions import AccessContentsInformation
from Products.CMFCore.permissions import ModifyPortalContent
from Products.CMFCore.permissions import RequestReview
from Products.CMFCore.permissions import ReviewPortalContent
from Products.CMFCore.permissions import View
from Products.CMFCore.permissions import DeleteObjects
from Products.CMFCore.permissions import ListFolderContents
from Products.CMFCore.WorkflowTool import addWorkflowFactory, _makeWorkflowFactoryKey
from Products.CMFCore.utils import getToolByName, manage_addTool

from Products.PloneInstallation.public import InstallationContext, CatalogInstaller, InstallationRunner

from Products.customsearch.config import *

def registerStylesheets(self, out, stylesheets):
    """ register additional CSS stylesheets with portal_css """
    csstool = getToolByName(self, 'portal_css')
    for css in stylesheets:
        csstool.registerStylesheet(**css)
    print >> out, "installed the Plone additional stylesheets."
    
    
def getInstallationRunner(self):
    """ PloneInstallation installer 
    
    TODO: Add uninstall support using PloneInstallation
    """
    
    runner = InstallationRunner()      
    return runner
                           
def install(self):
    """ Quick install script
    
    This script is executed when user chooses quickinstall in Zope Management Interface
    or Plone Management Page 
    
    @param portal Plone portal where are installing to
    """
    
    portal = self
    
    # Create buffer which logs messages during installation
    out = StringIO()

    # Register Archetypes types in the portal
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    # Register layout files in the portal
    install_subskin(self, out, GLOBALS)          
    
    # Register CSS definitions used by our product
    registerStylesheets(self, out, STYLESHEETS)

    ic = InstallationContext(self, GLOBALS)    
    ic.requiresInstalledProduct("DataGridField")        
    getInstallationRunner(self).install(ic, auto_reorder=1)

    out.write("Successfully installed %s." % PROJECTNAME)
    return out.getvalue()

def uninstall(self):
    ic = InstallationContext(self, GLOBALS)
    getInstallationRunner(self).uninstall(ic)
    