"""
    Module initialization code
    
    Copyright 2006 Red Innovation

"""

__author__  = 'Mikko Ohtamaa <mikko@redinnovation.com>'
__docformat__ = 'restructuredtext'

# Python imports
import os, os.path
import logging  

# Zope imports
from Globals import package_home

# Plone imports
from Products.CMFCore import utils as cmfutils
from Products.CMFCore import permissions as CMFCorePermissions
from Products.CMFCore import DirectoryView
from Products.CMFPlone.PloneUtilities import ToolInit
from Products.CMFCore.DirectoryView import registerDirectory
from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize

# Local imports
from config import *
from permissions import *

# Our logger object
LOG = logging.getLogger('CustomSearch')

# Initalize AdvancedQuery product utilized by CustomSearch
try:
    import Products.AdvancedQuery
except:
    LOG.error("AdvancedQuery Product not installed - CustomSearch is not functional")
    LOG.error("Get AdvancedQuery from http://www.dieter.handshake.de/pyprojects/zope/AdvancedQuery.html")

def initialize(context):
    from Products.customsearch import customsearch
    
    # register directory views
    registerDirectory('skins', GLOBALS)
   
    # initialize portal content
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    cmfutils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CUSTOM_SEARCH_PERMISSON,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)
        
    # yay! let the world know about us
    LOG.info("CustomSearch initialized")
    

