"""
    
    
    Drop down menu vocabularies
   
    Copyright 2006 Red Innovation
    
"""

__author__  = 'Mikko Ohtamaa <mikko@redinnovation.com>'
__docformat__ = 'restructuredtext'

from Products.Archetypes.public import *

from searchfields import *
from sorting import *
    
def getSearchTypes():    
    """ Generate edit mode drop down menu """
    return DisplayList(    
    (("value", "Value match",),
     ("minmax", "Minimum-maximum",),
     ("list", "Comma separated list of values",),         
     ("image", "Image displayed in results",),         
     ("path", "Content navigation path",),             
     ("boolean", "True of false value",),                 
    ))

def getSearchFieldVisibilityTypes():
    return DisplayList(    
    ((SearchField.VISIBILITY_QUERY_AND_RESULTS, "Query and results",),
     (SearchField.VISIBILITY_RESULTS, "Results",),
     (SearchField.VISIBILITY_QUERY, "Query",),
     (SearchField.VISIBILITY_NONE, "None",),
    ))
    
def getSearchFieldModes():             
    """ Generate edit mode drop down menu """
    return DisplayList(    
    ((SearchField.MODE_USER_EDITABLE, "User editable",),
     (SearchField.MODE_FIXED_VALUE, "Fixed value (default value)",),
    ))    
    
def getSortKeyModes():             
    """ Generate sort key mode drop down menu """
    return DisplayList(    
    ((SortKey.MODE_AVAILABLE_FOR_USER, "User can choose",),
     (SortKey.MODE_FORCED, "Forced before user keys",),
    ))        
    
def getSortKeyOrders():             
    """ Generate sort key order drop down menu """
    return DisplayList(    
    ((SortKey.ORDER_ASCENDING, "Ascending",),
     (SortKey.ORDER_DESCENDING, "Descending",),
    ))       